Subject: Re: [PATCH 2/4] datagram: mem_scheudle functions

From: Hideo AOKI <[email-masked]>
Date: Tue, 18 Dec 2007 12:02:15 -0500

Hello,

I really apologize for not replying to this mail sooner.

Herbert Xu wrote:
> On Mon, Dec 03, 2007 at 07:10:45PM -0500, Hideo AOKI wrote:
>> Because we have to call wmem_schedule function in ip_append_data()
>> which is used by several protocols both stream and datagram.
>> I just thought adding the sk_wmem_schedule() was only way to call
>> proper function from ip_append_data().
> 
> ip_append_data can't possibly work for stream protocols.  So
> which stream protocol is calling it?

I think TCP could call ip_append_data(). Here is possible call graph.

tcp_v4_rcv()
  -> tcp_v4_timewait_ack()
       -> tcp_v4_send_ack()
            -> ip_send_reply()
                 -> *ip_append_data()*

tcp_v4_reqsk_send_ack()
  -> tcp_v4_send_ack()
       -> ip_send_reply()
            -> *ip_append_data()*

tcp_v4_do_rcv()
  -> tcp_v4_send_reset()
       -> ip_send_reply()
            -> *ip_append_data()*

Regards,
Hideo

-- 
Hitachi Computer Products (America) Inc.